
InitPort:
		ldi temp1,0b00000011
		out DDRB,temp1
		ldi temp1,0b00111100
		out PortB,temp1
	   	
      ldi temp1,0b00011000
		out DDRC,temp1
		ldi temp1,0b00110000
		out PortC,temp1
		
		
		ldi temp1,0b11111100
		out DDRD,temp1
		ldi temp1,0b00000000
		out PortD,temp1
		ret

;*************************************************************************************

InitADC:		
		ldi temp1, 0b10001110	;ADC Initialisierung
		out ADCSR, temp1
		ldi Kanal,0b00100000	;Kanal 0 einstellen
		out ADMUX, Kanal
		ret
;****************************************************************************************

InitUSARTRec:		
		ldi temp1,0
		out UBRRH, temp1
		ldi temp1,12
		out UBRRL, temp1				;Baudrate = 38400 Baud, f=8MHz, U2X=0

		ldi temp1,0b10110110			;Parity: Odd		
		out UCSRC, temp1

		ldi temp1,0b10010000
		out UCSRB, temp1

		ldi temp1,0b00100000
		out UCSRA, temp1
		ret
;****************************************************************************************

InitUSARTTra:		
		ldi temp1,0
		out UBRRH, temp1
		ldi temp1,12
		out UBRRL, temp1				;Baudrate = 38400 Baud, f=8MHz, U2X=0

		ldi temp1,0b10110110;0b10110110			;Parity:Odd	
		out UCSRC, temp1

		ldi temp1,0b01001000
		out UCSRB, temp1

		ldi temp1,0b00100000
		out UCSRA, temp1
		ret


;****************************************************************************************

InitTimer0:		
		
		in temp1, TIMSK			;TOIE0 in TIMSK setzen und damit Timer0OV Int freigeben
		sbr temp1,1<<TOIE0
		out TIMSK, temp1		
		
		ldi temp1,0b00000100    ;Prescaler = 256 -> 8,192ms Takt	
		out TCCR0,temp1			;
		ret						

;****************************************************************************************
InitTimer1:                  ;Timer 1 fr Wait von 1-Wire Bus
		ldi temp1,TSTOP		
      out TCCR1A,temp1
      out TCCR1B,temp1
      ret

;**********************************************************************************

InitTimer2:		
		in temp1,ASSR             ;Timer2 fr 1 Sekunden Takt
		sbr temp1,1<<AS2
		out ASSR,temp1
		in temp1,TCCR2
		sbr temp1,1<<CS22
		out TCCR2,temp1
		in temp1,TIMSK
		sbr temp1,1<<TOIE2
		out TIMSK,temp1		
		ret
		
;****************************************************************************************
InitRAM:
	
	   ldi temp1,0xFF
	   sts SSTastenOld,temp1
	
		clr temp1
		
		sts SSAktEbene,temp1
		sts SSEbene0,temp1
		sts SSEbene1,temp1
		sts SSEbene2,temp1
		sts SSEbeneMin,temp1		
		sts SSEbeneEinsp,temp1		
		sts SSScroll,temp1
		sts SSZeileCursor,temp1
		sts SSADC0,temp1
		sts SSADC1,temp1
		sts SSADC2,temp1
		sts SSADC3,temp1
		sts SSZaT0,temp1
		sts SSTasten,temp1
		sts SSBitByte,temp1
		sts SSBitByte1,temp1		
		sts SSNull,temp1
		sts SSZeileCursorE0,temp1
		sts SSZeileCursorE1,temp1	
		sts SSNull1,temp1
		
		sts SSTemp1,temp1
		sts SSTemp2,temp1
		sts SSTemp3,temp1
		sts SSTemp4,temp1
		sts SSTemp5,temp1
		sts SSTemp6,temp1
		sts SSTemp7,temp1
		sts SSTemp8,temp1
		sts SSDruck1,temp1
		sts SSDruck2,temp1
		sts SSMAnzZeile2,temp1
		sts SSMAnzZeile3,temp1
		sts SSMAnzZeile4,temp1

		sts SSZeilenZa,temp1
		sts SSTaOKZa,temp1
		
		ldi temp1,1
		sts SST2Za,temp1
		
		ldi temp1,1
		sts SSCursorIndex,temp1
		
		ldi temp1,0
		sts SSMenu,temp1
		sts SSGewMenu,temp1
		
		ldi temp1,PCaktivPreSc
		sts SSZaPCaktiv,temp1
		
		ldi temp1,LEDPreSc
		sts SSZaLED,temp1
		
		
		ldi ZL,low(TempMSt0)    ;TempMSt0-7 lschen
		ldi ZH,high(TempMSt0)
		clr temp1
ClearTempMem:
		st Z+,temp1		
		cpi ZL,low(TempMSt7+2)
		brne ClearTempMem

		ldi ZL,low(MStIndex0)   ;MStIndex0-7 auf 0 stellen
		ldi ZH,high(MStIndex0)
		clr temp1
ClearMStMem:
		st Z+,temp1		
	   cpi ZL,low(MStIndex7+1)
		brne ClearMStMem
		
		
	   ret

;************************************************************************************************

InitLCD:	
        rcall lcd_init     		;Display initialisieren
        rcall lcd_clear    		;Display lschen  		
		  rcall LcdZ1
		 							
		  ret

;*********************************************************************************

InitEEPROM:
		sbi EECR,EERIE
		reti


;********************************************************************************************

InitSleep:
      in temp1,MCUCR
      sbr temp1,(1<<SM1|1<<SM0)
		out MCUCR,temp1

		ret

;********************************************************************************************

Init1WireBus:		
      rcall  GetROMS
 	
 	
 		clr temp4
 		cp ROMCount,temp4         ;Device not found
 		breq EndeInit1WireBus
 		
RdMStNr: 			              ;MessStellenNummern von allen Fhler auslesen
 		mov temp1,temp4
 		rcall IndexToOffset    ;und in MStIndex0-7 speichern
 		push temp4
 		rcall ReadScratch
 		pop temp4

		ldi ZL,low(MStIndex0)
		ldi ZH,high(MStIndex0)
		
		add ZL,temp4
		clr temp1		
		adc ZH,temp1
		lds temp1,TLUB2
		st Z,temp1
		
 		inc temp4
 	   cp temp4,ROMCount
 	   brne RdMStNr

EndeInit1WireBus: 	
      ret





















































